% F2SINGULARF  Enforce det(F)=0 for a given 3x3 matrix F
%
% Given a candidate fundamental matrix F, compute a corrected matrix by
% zeroing the smallest singular value
%
% Input: 
%   - F(3,3) : matrix
%
% Output:
%   - f(3,3) : matrix such that det(F)=0


function f = F2SingularF(F)
[u,s,v]=svd(F);
s(3,3)=0;
f=u*s*v';