% Lab session #3  Two-view geometry
% Test for fundamental matrix estimation
%
% Guillermo Gallego

% You can run the entire script by pressing the F5 key
% Or, you can evaluate one or more lines by selecting them and pressing the
% F9 key (without needing to copy them to the prompt in the Command Window)

clear all % clear all variables in the workspace
close all % close all figures
clc       % clear the command window


%% Fundamental matrix estimation via the (normalized) 8-point algorithm
% Simulated scene with error-free correspondences
N = 40;          % Number of 3-D points
X = randn(4,N);  % Homogeneous coordinates of 3-D points
P1 = randn(3,4); % Projection matrices
P2 = randn(3,4);
x1 = P1 * X;     % Image (i.e., projected) points
x2 = P2 * X;

% Add noise
sigma = 1e-1;
x1 = x1 + sigma * randn(size(x1));
x2 = x2 + sigma * randn(size(x2));


%% Estimate fundamental matrix: RANSAC + 8-point algorithm
obs_points = [x1; x2]; % Combine points in both images into a single variable

% Estimate fundamental matrix using RANSAC
fittingfn = @fund_fitting;
distfn    = @fund_dist;
degenfn   = @fund_isdegenerate;
s = ; % number of points that @fund_fitting uses to define a fundamental matrix
t = 1; % pixel unit. Inlier classification threshold

% Call ransac function. Use as an example the code provided for lie fitting
% Use obs_points as an input argument to ransac()


% Print number of points and number of inliers


% Measure point-to-epipolar line distance
cost_dist_epi_line = DistPoint2EpipolarLine(F,x1,x2)
