% Lab session #3  Two-view geometry
% Test for fundamental matrix estimation
%
% Guillermo Gallego

% You can run the entire script by pressing the F5 key
% Or, you can evaluate one or more lines by selecting them and pressing the
% F9 key (without needing to copy them to the prompt in the Command Window)

clear all % clear all variables in the workspace
close all % close all figures
clc       % clear the command window


%% Fundamental matrix estimation via the (normalized) 8-point algorithm
% Simulated scene with error-free correspondences
N = 40;          % Number of 3-D points
X = randn(4,N);  % Homogeneous coordinates of 3-D points

X(3, :) = X(3, :) * 5 + 10;
X(4, :) = 1;

P1 =   [500 0 320 0
        0 500 240 0
        0 0 1 0];

P2 =   [500 0 320 -100
        0 500 240 0
        0 0 1 0];
				
x1 = P1 * X;     % Image (i.e., projected) points
x2 = P2 * X;

% Estimate fundamental matrix
% Call the 8-point algorithm on inputs x1, x2
F = ;

% Check the epipolar constraint x2(i).' * F * x1(i) = 0 for all points i.
norm( sum(x2.*(F*x1)) ) / sqrt(N)
cost_dist_epi_line = DistPoint2EpipolarLine(F,x1,x2)


%% Test with noise:
sigma = 1e-1;
x1 = x1 + sigma * randn(size(x1));
x2 = x2 + sigma * randn(size(x2));

% Estimate fundamental matrix
% Call the 8-point algorithm on noisy inputs x1, x2
F = ;

% Check the epipolar constraint x2(i).' * F * x1(i) = 0 for all points i.
norm( sum(x2.*(F*x1)) ) / sqrt(N)
cost_dist_epi_line = DistPoint2EpipolarLine(F,x1,x2)


%% Normalized 8-point algorithm
% Call the normalized 8-point algorithm on inputs x1, x2
Fn = ;

% Check the epipolar constraint x2(i).' * F * x1(i) = 0 for all points i.
norm( sum(x2.*(Fn*x1)) ) / sqrt(N)
cost_dist_epi_line = DistPoint2EpipolarLine(Fn,x1,x2)
