% Function to calculate distances between a line and an array of points.
% The line is defined by its homogeneous coordinates

function [inliers, M] = line_dist(M, x, t)

npts = size(x,2);

% Perpendicular distance from each point to the line
M = M/norm(M(1:2)); % homog coordinates but with unit normal to the line
d = sum(M.'*[x; ones(1,npts)],1);
d = d(:); % column vector. Array of distance values.

inliers = find(abs(d) < t);